{*******************************************}
{                                           }
{            FastReport v2.2                }
{          Objet complmentaire             }
{       Dessin gomtrique standard         }
{                                           }
{ FastReport :(c) 1998-99 by Tzyganenko A.  }
{ RoundRect  : Guilbaud Olivier             }
{                golivier@worldnet.fr       }
{ Merci de transmettre vos commantaires     }
{                                           }
{Ce composant est un FREEWARE               }
{*******************************************}
{Histo :                                    }
{ 01/06/1999 : Cration                     }

unit Fr_Shape;

interface

uses
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    StdCtrls, ExtCtrls, FR_Class, FR_Utils, Buttons;


type
 TFrShape = (shCercle,shRectangle,shLigneV,shLigneH);

 TfrShapeObject= class(TComponent)  // fake component
  end;


 TfrShapeView = class(TfrView)
  public
    FtypeShape : TFrShape;
    FTrans     : Boolean;

    constructor Create; override;
    procedure Assign(From:TfrView); override;

    procedure Draw(Canvas:TCanvas); override;
    procedure ShowBackGround; override;
    procedure LoadFromStream(Stream:TStream); override;
    procedure SaveToStream(Stream:TStream); override;
  end;

  // L'EDITEUR DE PROP
  TFrShapeEditor = class(TfrObjEditorForm)
    RBShape: TRadioGroup;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Image1: TImage;
    cbTrans: TCheckBox;
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure ShowEditor(t:TfrView); override;
  end;

Procedure Register;

implementation
{$R *.DFM}

var FrShapeEditor: TFrShapeEditor;


//---------------------- DEFINE SHAPE -----------------//
constructor TfrShapeView.Create;
Begin
  Inherited Create;

  //Typ :=gtImage;
  Flags := 1;
  FTypeShape:=shCercle; // Cercle ici
  FTrans    :=False;
  FillColor :=clNone;
end;

procedure TfrShapeView.Assign(From:TfrView);
Begin
  inherited Assign(From);

  FTypeShape:=(From as TFrShapeView).FTypeShape;
  FTrans    :=(From as TFrShapeView).FTrans;
end;

procedure TFrShapeView.ShowBackGround;
Begin
 if DisableDrawing then Exit;
 if (DocMode = dmPrinting) then Exit;

  // ne fait rien
  With Canvas do
  begin
    Brush.Style:=bsClear;
    Brush.Color:=clNone;

    Rectangle(X,Y,X+DX,Y+DY);
  end;
end;

procedure TFrShapeView.Draw(Canvas:TCanvas);
Begin
  BeginDraw(Canvas); // Initialise le canvas utilis
  CalcGaps;          // Calcule les coordonnes utiles
  with Canvas do
  begin
    CopyMode:=cmSrcErase;

    ShowBackground;  // Dessine le fond

    // Initialise le crayon utilis
    Pen.Style := psSolid;
    Pen.Width :=FrameWidth;
    Pen.Color:=FrameColor;

    // remplissage
    If FTrans then
    begin
      Brush.Style:=bsClear;
      Brush.Color:=clnone;
    end
    else
    begin
      Brush.Style:=bsSolid;
      Brush.Color:=FillColor;
    end;


    Case FTypeShape of
     shCercle     : Ellipse(X,Y,X+DX,Y+DY);
     shRectangle  : Rectangle(X,Y,X+DX,Y+DY);
     shLigneV     : Begin
                      MoveTo(X+(DX div 2),Y);
                      LineTo(X+(DX div 2),Y+DY);
                    end;
     shLigneH     : Begin
                      MoveTo(X,Y+(DY div 2));
                      LineTo(X+DX,Y+(DY div 2));
                    end;
    end;
  end;
end;

procedure TFrShapeView.LoadFromStream(Stream:TStream);
Begin
  inherited LoadFromStream(Stream);
  Stream.Read(FTypeShape,SizeOf(FTypeShape));
end;

procedure TFrShapeView.SaveToStream(Stream:TStream);
begin
  inherited SaveToStream(Stream);
  Stream.Write(FTypeShape,SizeOf(FTypeShape));
end;

//--------------------- EDITOR ------------------------//

procedure TFrShapeEditor.ShowEditor(t:TfrView);
begin
  RBShape.ItemIndex:=Ord((t as TFrShapeView).FTypeShape);
  CBTrans.Checked:=(t as TFrShapeView).FTrans;

  If ShowModal=mrOk then
  begin
   (t as TFrShapeView).FTypeShape:=TFrShape(RBShape.ItemIndex);
   (t as TFrShapeView).FTrans    :=CBTrans.Checked;
  end;
end;

Procedure Register;
begin
RegisterComponents('FastReport',[TfrShapeObject]);
end;

initialization
  FrShapeEditor:= TFrShapeEditor.Create(nil);
  frRegisterObject(TfrShapeView,FrShapeEditor.Image1.Picture.Bitmap,
    frLoadStr('sShapeEditor'),FrShapeEditor);

finalization
  FrShapeEditor.Free;

end.
